#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <clib/dos_protos.h>
#include <clib/exec_protos.h>
#include <dos/dos.h>
#include <exec/types.h>
#include <exec/memory.h>

volatile const char ver[] = "$VER: ListModes 2.0 (14.1.96) (c) 1996 by Klaus Burkert";

struct BaseModeDefinition {
        ULONG   PixelClock;     /* in Hz                                  */
        UWORD   HDisplayEnd;    /* in Pixel (multiples of 8)              */
        UWORD   HSyncStart;     /*    "           "                       */
        UWORD   HSyncEnd;       /*    "           "                       */
        UWORD   HTotal;         /*    "           "                       */
        UWORD   VDisplayEnd;    /* in Lines                               */
        UWORD   VSyncStart;     /*   "                                    */
        UWORD   VSyncEnd;       /*   "                                    */
        UWORD   VTotal;         /*   "                                    */
        UWORD   ColorMode;
        UWORD   Flags;
        UWORD   Width;
        UWORD   Height;
        UWORD   HPosition;
        UWORD   VPosition;
        };

/* defines for BaseModeDefinition.ColorMode */

/* defines for BaseModeDefinition.Flags */
//#define         BMDF_HSYNC              0x01    // if set, positive
//#define         BMDF_VSYNC              0x02    // if set, positive
#define         BMDF_SCANMODEMASK       0x0C
#define         BMDF_SCAN_NORMAL        0x00
#define         BMDF_SCAN_INTERLACE     0x04
#define         BMDF_SCAN_DOUBLESCAN    0x08
//#define         BMDF_FBAS               0x10    // if set, enable Video
#define         BMDF_MODE_INTUIABLE     0x40    // if set, available for Intuition
#define         BMDF_MODE_AVAILABLE     0x80    // if set, mode is available

main(argc, argv)
char **argv;
int argc;
{
        BPTR in;
        struct FileInfoBlock fib;
        UBYTE *mem;
        struct BaseModeDefinition *mode;
        int i,j=0;
        long ref;

        if (argc != 2)
        {
                fprintf(stderr, "USAGE: ListModes <filename>\n");
                exit(10);
        }

        if (strcmp("?", argv[1]) == 0)
        {
                fprintf(stderr, "USAGE: ListModes <filename>\n");
                exit(10);
        }

        if (!(in = Open(argv[1], MODE_OLDFILE)))
        {
                fprintf(stderr, "ERROR: can't open input file %s\n",argv[1]);
                exit(10);
        }

        if (!(ExamineFH(in, &fib)))
        {
                fprintf(stderr, "ERROR: can't examine input file %s\n",argv[1]);
                Close(in);
                exit(10);
        }

        if (!(mem=AllocMem(fib.fib_Size, MEMF_PUBLIC)))
        {
                fprintf(stderr, "ERROR: can't alloc memory for input file %s\n",argv[1]);
                Close(in);
                exit(10);
        }

        Read(in, mem, fib.fib_Size);

        Close(in);

        mode = (struct BaseModeDefinition *)&(mem[122]);

        for(i=0; i<16; i++, mode++)
        {
                if((mode->Flags & BMDF_MODE_AVAILABLE) && (mode->Flags & BMDF_MODE_INTUIABLE))
                {
                        ref = (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_INTERLACE) ? 2 : 1) *
                        mode->PixelClock / mode->HTotal /mode->VTotal /
                        (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_DOUBLESCAN) ? 2 : 1);

                        printf("%2d %9d  %4d %4d %2d  %4d %4d %4d %4d %4d  %4d %4d %4d %4d %4d \n",
                        ++j,
                        mode->PixelClock,
                        mode->HDisplayEnd, mode->VDisplayEnd, 1,
                        mode->HDisplayEnd, mode->HSyncStart, mode->HSyncEnd, mode->HTotal, mode->HTotal,
                        mode->VDisplayEnd, mode->VSyncStart, mode->VSyncEnd, mode->VTotal, mode->VTotal);
                }
        }

        mode = (struct BaseModeDefinition *)&(mem[122]);

        for(i=0; i<16; i++, mode++)
        {
                if(mode->Flags & BMDF_MODE_AVAILABLE)
                {
                        ref = (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_INTERLACE) ? 2 : 1) *
                        mode->PixelClock / mode->HTotal /mode->VTotal /
                        (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_DOUBLESCAN) ? 2 : 1);

                        printf("%2d %9d  %4d %4d %2d  %4d %4d %4d %4d %4d  %4d %4d %4d %4d %4d \n",
                        ++j,
                        mode->PixelClock,
                        mode->HDisplayEnd, mode->VDisplayEnd, 8,
                        mode->HDisplayEnd, mode->HSyncStart, mode->HSyncEnd, mode->HTotal, mode->HTotal,
                        mode->VDisplayEnd, mode->VSyncStart, mode->VSyncEnd, mode->VTotal, mode->VTotal);
                }
        }

        for(i=0; i<16; i++, mode++)
        {
                if(mode->Flags & BMDF_MODE_AVAILABLE)
                {
                        ref = (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_INTERLACE) ? 2 : 1) *
                        mode->PixelClock / mode->HTotal /mode->VTotal /
                        (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_DOUBLESCAN) ? 2 : 1);

                        printf("%2d %9d  %4d %4d %2d  %4d %4d %4d %4d %4d  %4d %4d %4d %4d %4d \n",
                        ++j,
                        mode->PixelClock,
                        mode->HDisplayEnd, mode->VDisplayEnd, 16,
                        mode->HDisplayEnd, mode->HSyncStart, mode->HSyncEnd, mode->HTotal, mode->HTotal,
                        mode->VDisplayEnd, mode->VSyncStart, mode->VSyncEnd, mode->VTotal, mode->VTotal);
                }
        }

        for(i=0; i<16; i++, mode++)
        {
                if(mode->Flags & BMDF_MODE_AVAILABLE)
                {
                        ref = (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_INTERLACE) ? 2 : 1) *
                        mode->PixelClock / mode->HTotal /mode->VTotal /
                        (((mode->Flags & BMDF_SCANMODEMASK) == BMDF_SCAN_DOUBLESCAN) ? 2 : 1);

                        printf("%2d %9d  %4d %4d %2d  %4d %4d %4d %4d %4d  %4d %4d %4d %4d %4d \n",
                        ++j,
                        mode->PixelClock,
                        mode->HDisplayEnd, mode->VDisplayEnd, 24,
                        mode->HDisplayEnd, mode->HSyncStart, mode->HSyncEnd, mode->HTotal, mode->HTotal,
                        mode->VDisplayEnd, mode->VSyncStart, mode->VSyncEnd, mode->VTotal, mode->VTotal);
                }
        }


        FreeMem(mem, fib.fib_Size);
}
